<template>
  <div class="sa-select">
    <button
      :id="uniqueId"
      ref="button"
      :class="buttonClasses"
      aria-haspopup="listbox"
      :aria-expanded="dropdownOpen"
      :data-testid="buttonLabel"
      @click="toggleDropdown()"
    >
      <span>{{ buttonLabel }}</span>
      <sa-icon icon="chevron-down" />
    </button>
    <div
      v-show="dropdownOpen"
      ref="dropdown"
      class="dropdown"
      :class="align"
      role="listbox"
      :aria-labelledby="uniqueId"
      :aria-multiselectable="!isSingleMode"
      tabindex="0"
      @keydown.down.prevent="$refs.optionList.focusFirst"
      @keydown.up.prevent="$refs.optionList.focusLast"
      @keydown.esc.prevent="closeDropdown"
      @focus="onDropdownFocus"
      @focusout="onDropdownFocusOut"
    >
      <div v-if="showHeading || showCount || typeahead" class="header">
        <div v-if="showHeading" class="label">
          <span v-if="isSingleMode" class="single">Select one</span>
          <span v-else class="multi">Select multiple</span>
          <button
            v-if="checked.length > 0"
            class="clear-select"
            data-testid="button-clear"
            @click="selectNone()"
          >
            Clear
          </button>
        </div>
        <div v-if="showCount" class="option-count">
          <sa-caption
            :text="pluralize('% Option', matchedOptionsList.length)"
          />
        </div>
        <div v-if="typeahead" class="typeahead-container">
          <sa-input-search
            class="typeahead"
            size="small"
            :timeout="0"
            @change="onTypeaheadChange"
          />
        </div>
      </div>
      <sa-option-list
        ref="optionList"
        :options="visibleOptionsList"
        :single-mode="isSingleMode"
        :selection="checked"
        @toggle="toggleOption"
      />
    </div>
  </div>
</template>

<script>
import SaOptionList from '@/components/_utils/optionList/SaOptionList'

export default {
  name: 'SaSelect',
  components: { SaOptionList },
  props: {
    /** @values small, regular, large */
    size: {
      type: String,
      default: 'regular'
    },
    /** Array of strings or array of objects with `value` and `label` properties */
    options: {
      type: Array,
      default: () => []
    },
    /** Allow more than one value to be selected */
    multiselect: {
      type: Boolean,
      default: false
    },
    /** Text to show on input when there is no selection */
    label: {
      type: String,
      default: 'Select'
    },
    /** Items which should be selected when rendering the component */
    initialSelection: {
      type: Array,
      default: () => []
    },
    /** Allow the input to grow to fill the available width */
    fullWidth: {
      type: Boolean,
      default: false
    },
    /** Set to false to hide the dropdown heading prompt and selection clear button */
    showHeading: {
      type: Boolean,
      default: true
    },
    /** Set to false to hide the count of items in the dropdown */
    showCount: {
      type: Boolean,
      default: true
    },
    /**
     * Which side to align the button and dropdown panel
     * @values left, right
     */
    align: {
      type: String,
      default: 'left'
    },
    /** Show a text input to filter the list of available options */
    typeahead: {
      type: Boolean,
      default: false
    },
    /** Limit the number of options displayed */
    maxOptions: {
      type: Number,
      default: 0
    }
  },
  data(props) {
    const optionsList = props.options.map((option) => {
      if (typeof option === 'object') {
        option = { ...option }
      } else {
        option = {
          value: option,
          label: option
        }
      }
      option.selected = props.initialSelection.includes(option.value)
      return option
    })

    return {
      optionsList,
      dropdownOpen: false,
      uniqueId: this.makeUniqueId(),
      typeaheadValue: null
    }
  },
  computed: {
    matchedOptionsList() {
      if (this.typeaheadValue) {
        const re = new RegExp(this.typeaheadValue, 'i')
        return this.optionsList.filter((option) => {
          return option.value.match(re) || option.label.match(re)
        })
      }
      return this.optionsList
    },
    visibleOptionsList() {
      const options = this.typeahead
        ? this.matchedOptionsList
        : this.optionsList
      return this.maxOptions ? options.slice(0, this.maxOptions) : options
    },
    checked() {
      return this.optionsList
        .filter((option) => option.selected)
        .map((option) => option.value)
    },
    buttonClasses() {
      const classes = ['select', this.size]
      if (this.checked.length !== 0) {
        classes.push('selected')
      }
      if (this.fullWidth) {
        classes.push('full-width')
      }
      return classes
    },
    isSingleMode() {
      return !this.multiselect
    },
    buttonLabel() {
      const numChecked = this.checked.length
      if (numChecked === 0) {
        return this.label
      }
      if (numChecked === 1) {
        let label
        this.optionsList.forEach((option) => {
          if (option.selected) {
            label = option.label
          }
        })

        return label
      }
      return numChecked + ' ' + this.label
    }
  },
  methods: {
    toggleDropdown() {
      if (!this.dropdownOpen) {
        this.dropdownOpen = true
        setTimeout(() => this.$refs.dropdown.focus())
      } else {
        this.closeDropdown()
      }
    },
    closeDropdown() {
      this.dropdownOpen = false
      this.$refs.button.focus()
    },
    toggleOption(value) {
      if (this.isSingleMode) {
        this.optionsList.forEach((option) => {
          option.selected = value === option.value
        })
      } else {
        const option = this.optionsList.find((option) => value === option.value)
        option.selected = !option.selected
      }
      this.selectionChanged()
    },
    selectNone() {
      this.optionsList.forEach((option) => {
        option.selected = false
      })
      if (!this.isSingleMode) {
        this.$refs.dropdown.focus()
      }
      this.selectionChanged()
    },
    selectionChanged() {
      if (this.isSingleMode) {
        this.closeDropdown()
      }
      /**
       * Selection was changed. The current selection is always returned as
       * an array, even for single select.
       * @param {String[]} selection
       */
      this.$emit('change', [...this.checked])
    },
    onTypeaheadChange(value) {
      this.typeaheadValue = value
    },
    onDropdownFocus() {},
    onDropdownFocusOut(e) {
      if (!e.currentTarget.contains(e.relatedTarget)) {
        this.closeDropdown()
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.sa-select {
  position: relative;
}
.select {
  &:not(.full-width) {
    max-width: 20rem;
  }
  span {
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
  }
}
.header {
  position: sticky;
  top: 0;
  margin: 1px;
  padding-bottom: spacing(1);
  background: color(white);
  z-index: 10;
}
.label {
  display: flex;
  justify-content: space-between;
}
.clear-select {
  margin-left: spacing(2);
  font-size: font-size(0);
  text-decoration: underline;
  color: color(primary);
  &:hover,
  &:focus {
    text-decoration: none;
    color: color(grey);
  }
}
.typeahead {
  width: 100%;
}
</style>
